FILE(1)

NAME
file - determine file type

SYNOPSIS
file [-0bCcehikLNnprsvz] [--help] [--mime-encoding] [--mime-type] [-F separator] [-f namefile] [-m magicfiles] file

DESCRIPTION
The file utility tests each argument in an attempt to classify it. There are three sets of tests, performed in this order: filesystem tests, magic tests, and language tests. The first test that succeeds causes the file type to be printed.

The type printed will usually contain one of the words text (the file contains only printing characters and a few common control characters and is probably safe to read on an ASCII terminal), executable (the file contains the result of compiling a program in a form understandable to some UNIX kernel or another), or data meaning anything else (data is usually “binary” or non-printable). Exceptions are well-known file formats (core files, tar archives) that are known to contain binary data. When modifying magic files or the program itself, make sure to preserve these keywords. Users depend on knowing that all the readable files in a directory have the word “text” printed. Don't do as Berkeley did and change “shell commands text” to “shell script”.

The filesystem tests are based on examining the return from a stat(2) system call. The program checks to see if the file is empty, or if it's some sort of special file. Any known file types, such as sockets, symbolic links, and named pipes (FIFOs), are intuited if they are defined in the system header file <sys/stat.h>.

The magic tests are used to check for files with data in particular fixed formats. The canonical example of this is a binary executable (compiled program) a.out file, whose format is defined in <elf.h>, <a.out.h>, and possibly <exec.h> in the standard include directory. These files have a “magic number” stored in a particular place near the beginning of the file that tells the UNIX operating system that the file is a binary executable, and which of several types thereof. The concept of a “magic” has been applied by extension to data files. Any file with some invariant identifier at a small fixed offset into the file can usually be described in this way. The information identifying these files is read from the magic file /etc/magic. In addition, if $HOME/.magic.mgc or $HOME/.magic exists, it will be used in preference to the system magic files.

If a file does not match any of the entries in the magic file, it is examined to see if it seems to be a text file. ASCII, ISO-8859-x, non-ISO 8-bit extended-ASCII character sets (such as those used on Macintosh and IBM PC systems), UTF-8-encoded Unicode, UTF-16-encoded Unicode, and EBCDIC character sets can be distinguished by the different ranges and sequences of bytes that constitute printable text in each set. If a file passes any of these tests, its character set is reported. ASCII, ISO-8859-x, UTF-8, and extended-ASCII files are identified as “text” because they will be mostly readable on nearly any terminal; UTF-16 and EBCDIC are only “character data” because, while they contain text, it is text that will require translation before it can be read. In addition, file will attempt to determine other characteristics of text-type files. If the lines of a file are terminated by CR, CRLF, or NEL, instead of the Unix-standard LF, this will be reported. Files that contain embedded escape sequences or overstriking will also be identified.

Once file has determined the character set used in a text-type file, it will attempt to determine in what language the file is written. The language tests look for particular strings (cf. <names.h>) that can appear anywhere in the first few blocks of a file. For example, the keyword .br indicates that the file is most likely a troff input file, just as the keyword struct indicates a C program. These tests are less reliable than the previous two groups, so they are performed last. The language test routines also test for some miscellany (such as tar(1) archives).

Any file that cannot be identified as having been written in any of the character sets listed above is simply said to be “data”.

OPTIONS

-0, --print0
    Output a null character ‘\0’ after the end of the filename. Nice to cut(1) the output. This does not affect the separator which is still printed.

-b, --brief
    Do not prepend filenames to output lines (brief mode).

-C, --compile
    Write a magic.mgc output file that contains a pre-parsed version of the magic file or directory.

-c, --checking-printout
    Cause a checking printout of the parsed form of the magic file. This is usually used in conjunction with the -m flag to debug a new magic file before installing it.

-e, --exclude testname
    Exclude the test named in testname from the list of tests made to determine the file type. Valid test names are:

    apptype
        Check for EMX application type (only on EMX).

    ascii
        Check for various types of ASCII files.

    compress
        Don't look for, or inside, compressed files.

    elf Don't print elf details.

    fortran
        Don't look for fortran sequences inside ASCII files.

    soft
        Don't consult magic files.

    tar Don't examine tar files.

    token
        Don't look for known tokens inside ASCII files.

    troff
        Don't look for troff sequences inside ASCII files.

-F, --separator separator
    Use the specified string as the separator between the filename and the file result returned. Defaults to ‘’:.

-f, --files-from namefile
    Read the names of the files to be examined from namefile (one per line) before the argument list. Either namefile or at least one filename argument must be present; to test the standard input, use ‘-’ as a filename argument.

-h, --no-dereference
    Causes symlinks not to be followed. This is the default if the environment variable POSIXLY_CORRECT is not defined.

--help
    Print a help message and exit.

-i, --mime
    Causes the file command to output mime type strings rather than the more traditional human readable ones. Thus it may say “text/plain charset=us-ascii” rather than “ASCII text”. In order for this option to work, file changes the way it handles files recognized by the command itself (such as many of the text file types, directories etc.), and makes use of an alternative “magic” file. See also FILES, below.

--mime-encoding, --mime-type
    Like -i, but print only the specified element(s).

-k, --keep-going
    Don't stop at the first match, keep going. Subsequent matches will have the string “\012- ” prepended. (If a newline is required, see the -r option.)

-L, --dereference
    Causes symlinks to be followed; analogous to the option of the same name in ls(1). This is the default if the environment variable POSIXLY_CORRECT is defined.

-m, --magic-file magicfiles
    Specify an alternate list of files and directories containing magic. This can be a single item, or a colon-separated list. If a compiled magic file is found alongside a file or directory, it will be used instead.

-N, --no-pad
    Don't pad filenames so that they align in the output.

-n, --no-buffer
    Force stdout to be flushed after checking each file. This is only useful if checking a list of files. It is intended to be used by programs that want filetype output from a pipe.

-p, --preserve-date
    On systems that support utime(3) or utimes(2), attempt to preserve the access time of files analyzed, to pretend that file never read them.

-r, --raw
    Don't translate unprintable characters to \ooo. Normally file translates unprintable characters to their octal representation.

-s, --special-files
    Normally, file only attempts to read and determine the type of argument files which stat(2) reports are ordinary files. This prevents problems, because reading special files may have peculiar consequences. Specifying the -s option causes file to also read argument files which are block or character special files. This is useful for determining the filesystem types of the data in raw disk partitions, which are block special files. This option also causes file to disregard the file size as reported by stat(2) since on some systems it reports a zero size for raw disk partitions.

-v, --version
    Print the version of the program and exit.

-z, --uncompress
    Try to look inside compressed files.

ENVIRONMENT
The environment variable MAGIC can be used to set the default magic file name. If that variable is set, then file will not attempt to open $HOME/.magic. file adds “.mgc” to the value of this variable as appropriate. The environment variable POSIXLY_CORRECT controls whether file will attempt to follow symlinks or not. If set, then file follows symlinks; otherwise it does not. This is also controlled by the -L and -h options.

FILES
/etc/magic
    default list of magic numbers

EXIT STATUS

SEE ALSO
hexdump(1), od(1), strings(1), magic(5)

STANDARDS CONFORMANCE
This program is believed to exceed the System V Interface Definition of FILE(CMD), as near as one can determine from the vague language contained therein. Its behavior is mostly compatible with the System V program of the same name. This version knows more magic, however, so it will produce different (albeit more accurate) output in many cases.

The one significant difference between this version and System V is that this version treats any whitespace as a delimiter, so that spaces in pattern strings must be escaped. For example,

    10	string	language impress 	(imPRESS data)

in an existing magic file would have to be changed to

    10	string	language\ impress	(imPRESS data)

In addition, in this version, if a pattern string contains a backslash, it must be escaped. For example

    0	string		\begindata	Andrew Toolkit document

in an existing magic file would have to be changed to

    0	string		\\begindata	Andrew Toolkit document

SunOS releases 3.2 and later from Sun Microsystems include a file command derived from the System V one, but with some extensions. This version differs from Sun's only in minor ways. It includes the extension of the ‘&’ operator, used as, for example,

    16	long&0x7fffffff	0		not stripped

HISTORY
There has been a file command in every UNIX since at least Research Version 4 (man page dated November, 1973). The System V version introduced one significant major change: the external list of magic types. This slowed the program down slightly but made it a lot more flexible.

This program, based on the System V version, was written by Ian Darwin without looking at anybody else's source code.

John Gilmore revised the code extensively, making it better than the first version. Geoff Collyer found several inadequacies and provided some magic file entries. Contributions by the `&' operator by Rob McMahon, 1989.

Guy Harris, made many changes from 1993 to the present.

Primary development and maintenance from 1990 to the present by Christos Zoulas.

Altered by Chris Lowth, 2000: Handle the -i option to output mime type strings, using an alternative magic file and internal logic.

Altered by Eric Fischer, July, 2000, to identify character codes and attempt to identify the languages of non-ASCII files.

Altered by Reuben Thomas, 2007 to 2008, to improve MIME support and merge MIME and non-MIME magic, support directories as well as files of magic, apply many bug fixes and improve the build system.

The list of contributors to the “magic” directory (magic files) is too long to include here. You know who you are; thank you. Many contributors are listed in the source files.

BUGS
There must be a better way to automate the construction of the Magic file from all the glop in Magdir. What is it?

file uses several algorithms that favor speed over accuracy, thus it can be misled about the contents of text files.

The support for text files (primarily for programming languages) is simplistic, inefficient and requires recompilation to update.

The list of keywords in ascmagic probably belongs in the Magic file. This could be done by using some keyword like ‘*’ for the offset value.

Complain about conflicts in the magic file entries. Make a rule that the magic entries sort based on file offset rather than position within the magic file?

The program should provide a way to give an estimate of “how good” a guess is. We end up removing guesses (e.g. “Fromas first 5 chars of file) because” they are not as good as other guesses (e.g. “Newsgroups:” versus “Return-Path:”). Still, if the others don't pan out, it should be possible to use the first guess.

This manual page, and particularly this section, is too long.